#include "StdAfx.h"
#include "UpdateManager.h"
#include "AtatchDownload.h"



CUpdateManager::CUpdateManager(void)
{
	m_bUpdatable = FALSE;
	m_IniURL = _T("");
	m_strCurrentVer = _T("");
	m_nTotalCnt = 0;
    m_dwTotlaBytes = 0;
    m_hInternet = NULL;
    m_hURL = NULL;
}

CUpdateManager::~CUpdateManager(void)
{
	if( m_hURL != NULL )
	{
		InternetCloseHandle( m_hURL );
	}

	if( m_hInternet != NULL )
	{
		InternetCloseHandle( m_hInternet );
	}


	UPDATEFILEINFO* pItem = NULL;
	for(size_t i=0; i<m_vecUpdateFileInfo.size(); i++)
	{
		pItem = m_vecUpdateFileInfo.at(i);
		if (pItem)
		{
			delete pItem;
			pItem = NULL;
		}		
	}

	for(size_t j=0; j<m_vecLocalFileInfo.size(); j++)
	{
		pItem = m_vecLocalFileInfo.at(j);
		if (pItem)
		{
			delete pItem;
			pItem = NULL;
		}		
	}
}

int CUpdateManager::Init(LPCTSTR pszIniFilePath, LPCTSTR pszDownloadUrl, LPCTSTR pszInstallPath)
{
	int result = 0;
	TCHAR szDrive[_MAX_DRIVE];
	TCHAR szDir[_MAX_DIR];
	TCHAR szFilename[_MAX_FNAME];
	TCHAR szExt[_MAX_EXT];
	CString strFileName;
	UPDATEFILEINFO updateFileInfo;
	CString strIniUrl;


	// ٿε ini   ּҸ ...
	if(pszIniFilePath == NULL)
	{
		result = ERROR_INVALID_PARAMETER;
		goto finish;
	}

	_tsplitpath_s(pszIniFilePath, szDrive, szDir, szFilename, szExt);
	strFileName = szFilename;
	strFileName += szExt;

	CheckVersion(pszIniFilePath);

	strIniUrl = MakeIniUrl(pszDownloadUrl, strFileName);

	updateFileInfo.strDownloadFileName = CreateTempFileName();
	updateFileInfo.strFileName = strFileName;
	// ini ٿε ޴´..
	result = DownloadFile(strIniUrl, &updateFileInfo, NULL);

	// ini Ϸ  Ʈ  Ǵ  ִ  
	result = LoadUpdateFileInfo(updateFileInfo.strDownloadFileName);

	CopyFile(updateFileInfo.strDownloadFileName, pszIniFilePath, FALSE);
	DeleteFile(updateFileInfo.strDownloadFileName);

finish:
	return result;
}

CString CUpdateManager::MakeIniUrl(LPCTSTR pszUrl, LPCTSTR pszFileName)
{
	CString strUrl;

	strUrl = pszUrl;
	if(strUrl.Right(1)  != _T("/"))
	{
		strUrl += _T("/");
	}

	strUrl += pszFileName;


	return strUrl;
}


int CUpdateManager::DownloadFile(LPCTSTR pszURL, PUPDATEFILEINFO pFileInfo, LPVOID pInfo)
{
	m_hInternet = NULL;
	m_hURL = NULL;
	int result;
	HANDLE hDownLoadFile;
	hDownLoadFile = INVALID_HANDLE_VALUE;
	DWORD dwSize, dwRead, dwWritten, dwTotalWrittenBytes;
	BYTE baBuffer[ 1024 * 10 ];
	int nStatusCode;
	CString strDbg;
	WIN32_FIND_DATA findData;
	HANDLE hFind = INVALID_HANDLE_VALUE;
	int idx = 0;
	CString strFindFile = pFileInfo->strFileName;
	CString strFindPath;
	
	CAtatchDownload* pDlg = NULL;
	if (NULL != pInfo)
	{
		pDlg = (CAtatchDownload*) pInfo;
	}

	if(pszURL == NULL)
	{
		result = ERROR_INVALID_PARAMETER;		
		goto finish;
	}

	m_hInternet = InternetOpen(_T("NTalkbiz"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if( m_hInternet == NULL )
	{
		result = GetLastError();
		OutputDebugString(_T("InternetOpen()"));
		goto finish;
	}

	m_hURL = InternetOpenUrl(m_hInternet, pszURL, NULL, 0,  INTERNET_FLAG_RELOAD | INTERNET_FLAG_NO_CACHE_WRITE , 0);
	if(m_hURL == NULL)
	{
		result = GetLastError();
		OutputDebugString(_T( "InternetOpenUrl()"));
		goto finish;
	}
	
	dwSize = sizeof(baBuffer);
	result = HttpQueryInfo(m_hURL, HTTP_QUERY_STATUS_CODE, baBuffer, &dwSize, NULL);
	if( result == FALSE )
	{
		result = GetLastError();
		OutputDebugString(_T( "HttpQueryInfo()"));
		goto finish;
	}

	nStatusCode = _ttoi((LPCTSTR)baBuffer);
	if( nStatusCode == 404 )
	{
		//
		// ã, ׳ ŵ
		//		
		result = ERROR_NOT_FOUND;		
		goto finish;
	}
	else if((nStatusCode != 200) && (nStatusCode != 304))
	{

		result = GetLastError();		
		goto finish;
	}


	
	memset(&findData, 0x00, sizeof(WIN32_FIND_DATA));

	while(1)
	{
		strFindPath.Format(_T("%s\\%s"), pFileInfo->strFolder, strFindFile);
		hFind = FindFirstFile(strFindPath, &findData);
		if(hFind == INVALID_HANDLE_VALUE)
		{
			pDlg->SetFileRename(pFileInfo->strFileName, strFindFile);
			pFileInfo->strDownloadFileName = strFindPath;			
			break;
		}
		strFindFile = pFileInfo->strFileName;
		int nPos = strFindFile.ReverseFind(_T('.'));
		CString strIdx;
		strIdx.Format(_T("(%d)"), ++idx);
		if(nPos == -1)
		{
			strFindFile.Append(strIdx);
		}
		else
		{
			strFindFile.Insert(nPos, strIdx);		
		}		
	}
	
	
	hDownLoadFile = CreateFile(pFileInfo->strDownloadFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if( hDownLoadFile == INVALID_HANDLE_VALUE )
	{		
		CreateDirectoryTree(pFileInfo->strFolder);
		hDownLoadFile = CreateFile(pFileInfo->strDownloadFileName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hDownLoadFile == INVALID_HANDLE_VALUE )
		{
			result = GetLastError();			
			goto finish;
		}
	}

	if( pDlg != NULL )
	{
		pDlg->DownloadBegin(pFileInfo->nSize, (LPARAM)( (LPCTSTR)pFileInfo->strFileName));
	}

	dwTotalWrittenBytes = 0;

	int nLoopCnt = 0;
	do
	{
		result = InternetQueryDataAvailable(m_hURL, &dwSize, 0, 0);
		if( result == FALSE )
		{
			result = GetLastError();
			OutputDebugString(_T( "InternetQueryDataAvailable()"));
			goto finish;
		}
		
		//
		// ۰ Ѿ  ؼ...
		//
		if( dwSize > sizeof(baBuffer) )
		{
			dwSize = sizeof(baBuffer);
		}

		result = InternetReadFile(m_hURL, baBuffer, dwSize, &dwRead);
		if(result == FALSE)
		{
			result = GetLastError();
			strDbg.Format(_T("InternetReadFile()"));
			OutputDebugString(strDbg);
			goto finish;
		}

		result = WriteFile(hDownLoadFile, baBuffer, dwRead, &dwWritten, NULL);
		if(result == FALSE)
		{
			result = GetLastError();
			strDbg.Format(_T("WriteFile()"));
			OutputDebugString(strDbg);
			goto finish;
		}

		dwTotalWrittenBytes += dwWritten;

		nLoopCnt++;
		if(pDlg != NULL)
		{
			pDlg->DownloadBytes(dwWritten, dwTotalWrittenBytes);
		}
	} while(dwRead != 0);

	if(pDlg != NULL)
	{
		pDlg->DownloadEnd(dwWritten, (LPARAM)( (LPCTSTR)pFileInfo->strFileName));
	}

	result = 0;

finish:
	if(result != 0)
	{
		OutputDebugString(_T( "CUpdateManager::DownloadFile()"));
	}

	if( m_hURL != NULL )
	{
		InternetCloseHandle( m_hURL );
	}

	if( m_hInternet != NULL )
	{
		InternetCloseHandle( m_hInternet );
	}
	if( hDownLoadFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle( hDownLoadFile );
	}
	


	return result;
}


CString CUpdateManager::CreateTempFileName()
{
    //warning C6262: Function uses '24584' bytes of stack
    TCHAR szTempPath[MAX_PATH + 1] = {0};
    TCHAR szTempFileName[MAX_PATH + 1] = {0};
	CString strResult;

	GetTempPath(sizeof(szTempPath) / sizeof(TCHAR), szTempPath);
	GetTempFileName(szTempPath, _T(""), 0, szTempFileName);

	strResult.Format( _T("Temp File Name : %s"), szTempFileName );
	OutputDebugString( strResult );

	strResult = szTempFileName;

	return strResult;
}


int CUpdateManager::LoadUpdateFileInfo(LPCTSTR pszIniFilePath)
{
	int result = 0;
	TCHAR szBuffer[2048];
	int nBufferSize = DIM(szBuffer);
	int nLen, nRegist;
	vector<CString> vecUpdateFiles;
	vector<CString>::iterator iter;
	PUPDATEFILEINFO pUpdateFileInfo;
	CString strVersion = _T("");
	
	m_dwTotlaBytes = 0;

	nLen = GetPrivateProfileString(_T("UpdateInfo"), _T("URL"), _T(""), szBuffer, nBufferSize, pszIniFilePath);	
	szBuffer[nLen] = _T('\0');
	m_IniURL = szBuffer;
	
	nLen = GetPrivateProfileString(_T("UpdateInfo"), _T("Version"), _T(""), szBuffer, nBufferSize, pszIniFilePath);	
	szBuffer[nLen] = _T('\0');
	strVersion = szBuffer;

	//ι 
	if (strVersion == m_strCurrentVer)
		return 1;

	nLen = GetPrivateProfileString(_T("UpdateInfo"), _T("Files"), _T(""), szBuffer, nBufferSize, pszIniFilePath);	
	szBuffer[nLen] = _T('\0');
	result = SplitString(szBuffer, _T(';'), vecUpdateFiles);

	if(vecUpdateFiles.empty() == true)
	{
		result = -1;
		m_bUpdatable = FALSE;
		
	}
	else
	{
		iter = vecUpdateFiles.begin();
		for(; iter != vecUpdateFiles.end(); iter++)
		{
			nLen = GetPrivateProfileString(*iter, _T("Version"), _T(""), szBuffer, nBufferSize, pszIniFilePath);			
			szBuffer[nLen] = _T('\0');
			strVersion = szBuffer;

			if(IsUpdateFile(*iter, strVersion) == false)
				continue;

			pUpdateFileInfo = new UPDATEFILEINFO;
			if(pUpdateFileInfo == NULL)
			{
				result = ERROR_NOT_ENOUGH_MEMORY;
				goto finish;
			}

			pUpdateFileInfo->strFileName = (*iter);

			nLen = GetPrivateProfileString(pUpdateFileInfo->strFileName, _T("Folder"), _T(""), szBuffer, nBufferSize, pszIniFilePath);
			szBuffer[nLen] = _T('\0');

			//    
			pUpdateFileInfo->strFolder = GetFullPath(szBuffer);

			//Ʈ   ũ
			nLen = GetPrivateProfileString(pUpdateFileInfo->strFileName, _T("Size"), _T(""), szBuffer, nBufferSize, pszIniFilePath);
			szBuffer[nLen] = _T('\0');
			pUpdateFileInfo->nSize = _tstoi(szBuffer);
			m_dwTotlaBytes += pUpdateFileInfo->nSize;

			//ڵ
			nLen = GetPrivateProfileString(pUpdateFileInfo->strFileName, _T("SelfRegister"), _T(""), szBuffer, nBufferSize, pszIniFilePath);
			szBuffer[nLen] = _T('\0');
			nRegist = _tstoi(szBuffer);
			pUpdateFileInfo->bSelfRegist = nRegist == 1? TRUE:FALSE;
	
			m_vecUpdateFileInfo.push_back(pUpdateFileInfo);
			m_nTotalCnt++;
		}
		m_bUpdatable = TRUE;
	}

	

finish:
	return result;
}


int CUpdateManager::CheckVersion(LPCTSTR pszIniFilePath)
{
	int result = 0;
	TCHAR szBuffer[2048];
	int nBufferSize = DIM(szBuffer);
	int nLen;
	vector<CString> vecUpdateFiles;
	vector<CString>::iterator iter;
	PUPDATEFILEINFO pUpdateFileInfo;
	CString strVersion = _T("");

	nLen = GetPrivateProfileString(_T("UpdateInfo"), _T("Version"), _T(""), szBuffer, nBufferSize, pszIniFilePath);	
	szBuffer[nLen] = _T('\0');
	m_strCurrentVer = szBuffer;

	nLen = GetPrivateProfileString(_T("UpdateInfo"), _T("Files"), _T(""), szBuffer, nBufferSize, pszIniFilePath);	
	szBuffer[nLen] = _T('\0');
	result = SplitString(szBuffer, _T(';'), vecUpdateFiles);

	if(vecUpdateFiles.empty() == true)
	{
		result = -1;
	}
	else
	{
		iter = vecUpdateFiles.begin();
		for(; iter != vecUpdateFiles.end(); iter++)
		{
			pUpdateFileInfo = new UPDATEFILEINFO;
			if(pUpdateFileInfo == NULL)
			{
				result = ERROR_NOT_ENOUGH_MEMORY;
				goto finish;
			}

			m_vecLocalFileInfo.push_back(pUpdateFileInfo);

			pUpdateFileInfo->strFileName = (*iter);

			nLen = GetPrivateProfileString(pUpdateFileInfo->strFileName, _T("Version"), _T(""), szBuffer, nBufferSize, pszIniFilePath);			
			szBuffer[nLen] = _T('\0');			
			pUpdateFileInfo->strVersion = szBuffer;

		}

	}



finish:
	return result;	
}

CString CUpdateManager::GetFullPath(CString strFolder)
{
	//TCHAR szBuffer[4096];

	//GetCurrentDirectory(DIM(szBuffer), szBuffer);
	strFolder.Replace(_T("%CURRENTDIR%"), GetNtalkModulePath());

	return strFolder;
}

int CUpdateManager::DownloadUpdateFiles(LPVOID pInfo)
{
	size_t nSize = m_vecUpdateFileInfo.size();

	CString strIniUrl = _T("");
	CString strTmp = _T("");
	UPDATEFILEINFO* pUpdateFileInfo = NULL;
	size_t i=0;
	for (i =0; i<nSize; i++)
	{
		pUpdateFileInfo = m_vecUpdateFileInfo.at(i);
		if ((pInfo !=NULL) && (pUpdateFileInfo != NULL))
		{
			const wchar_t* ticket = L"&ticket=";

			pUpdateFileInfo->strURL.Append(ticket);
			std::string ticketValue = g_pMessengerActor->GetMessengerTicket();
			pUpdateFileInfo->strURL.Append(String2CString(ticketValue));

			if(DownloadFile(pUpdateFileInfo->strURL, pUpdateFileInfo, pInfo) != 0)
				AfxMessageBox(pUpdateFileInfo->strFileName);
		}
	}	
	return 0;
}

//    ؼ Ʈ  θ Ǵ
bool CUpdateManager::IsUpdateFile(CString strFileName, CString strVersion)
{
	UPDATEFILEINFO* pItem = NULL;
	for (size_t i=0; i<m_vecLocalFileInfo.size(); i++)
	{
		pItem = m_vecLocalFileInfo.at(i);
		if (pItem)
		{
			if(pItem->strFileName == strFileName)
			{
				if(pItem->strVersion == strVersion)
					return false;
				else
					return true;
			}
		}
	}

	return true;
}


void CUpdateManager::AddDownloadFile(CString strURL, CString strDownPath, CString strFileName, CString strSize)
{
	PUPDATEFILEINFO pUpdateFileInfo = new UPDATEFILEINFO;
	if(pUpdateFileInfo == NULL)
	{
		return;
	}
	
	pUpdateFileInfo->strFileName = strFileName;
	pUpdateFileInfo->strDownloadFileName = strDownPath +L"\\" + strFileName;
	pUpdateFileInfo->strURL = strURL;
	pUpdateFileInfo->strFolder = strDownPath;
	char* szSize = StringToChar(strSize);

	if (NULL != szSize)
	{
		pUpdateFileInfo->nSize = atoi(szSize);
		delete [] szSize; szSize = NULL;
	}
	m_vecUpdateFileInfo.push_back(pUpdateFileInfo);

	m_nTotalCnt ++;
}
